<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class JoomdControllerEntry extends JoomdController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		
		// Register Extra tasks
		$this->registerTask( 'add',	'edit' );
		$this->registerTask( 'apply', 'save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'unfeatured', 'featured' );
		
		require_once(JPATH_SITE.'/components/com_joomd/libraries/classes/fields.php');
		
		$this->field = new JoomdFields('entry');
		
		$this->field->checkType();
		
	}
	
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		
		JRequest::setVar( 'layout', 'form'  );
		
		$html = parent::edit();
		
		echo $html;
		
	}
	
	//to save/apply the item
	function save()
	{
		$model = $this->getModel('entry');
		
		$obj = $model->store();
		
		echo json_encode($obj);
		
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function delete()
	{
		$model = $this->getModel('entry');
		
		$json = new stdClass();
		
		if($model->delete())	{
						
			$msg = JText::_('EREVSUCC');
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
			
		}
		
		echo json_encode($json);

	}
	
	// publish/unpublish the items
	function publish()
	{
		$model = $this->getModel('entry');
		$task = $this->getTask();
		
		$json = new stdClass();
		
		if($model->publish())	{
			
			$data = $this->getItems();
			
			$msg = ($task=="publish")?JText::sprintf('PUBLISHSUCCESS', JText::_('ENTRY')):JText::sprintf('UNPUBLISHSUCCESS', JText::_('ENTRY'));
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
		
	}
	
	function featured()
	{
		$model = $this->getModel('entry');
		$task = $this->getTask();
		
		$json = $model->featured();
		
		echo json_encode($json);
		
	}
	
	//to reorder the items
	function reorder()
	{
	
		$model = $this->getModel('entry');
		
		$json = new stdClass();
		
		if($model->reorder())	{
			
			$data = $this->getItems();
			
			$msg = JText::_('EREORDSUCC');
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
	
	}
	
	//to save the ordering of all items
	function saveorder()
	{
	
		$model = $this->getModel('entry');
		
		$json = new stdClass();
		
		if($model->saveorder())	{
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = JText::_('EREORDSUCC');
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
						
		}
		else	{
			
			$json->result = "error";
			$json->error = $model->getError();
			
		}
		
		echo json_encode($json);
	
	}
	
	//to change the access level
	function access()
	{
		
		$model = $this->getModel('entry');
		
		$json = new stdClass();
		
		if($model->access())	{
			
			$data = $this->getItems();
			
			$msg = JText::_('ACCESSUPDATESUCCESS');
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
		
	}
	
	//prepare the rendering template for loading items
	function getItems()
	{
		
		$model = $this->getModel('entry');
		
		$items = $model->getItems();
		$params = $model->getParams();
		
		$this->firstfield =  $this->field->get_firstfield(array('core'=>false, 'type'=>array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11)));
		
		ob_start();
		
		$ordering = ($params->filter_order == 'i.ordering');
		
		$disabled = $ordering?'':'disabled="disabled"';
		
		$k = 0;
		$i = $params->limitstart;
		for ($n=0; $n < count( $items ); $n++)
		{
			$row =  $items[$n];
			
			require(JPATH_COMPONENT.DS.'views'.DS.'entry'.DS.'tmpl'.DS.'default_item.php');
			
			$k = 1 - $k;
			$i++;
			
		}
		
		$html = ob_get_contents();
		
		ob_end_clean();
		
		$data = new stdClass();
		
		$data->html = $html;
		$data->count = count($items);
		$data->total = $params->total;
		
		return $data;
		
	}
	
	//to reload the list for all operations
	function loaditems()
	{
		
		$data = $this->getItems();
		
		$json = new stdClass();
		
		$json->result = "success";
		$json->html = $data->html;
		$json->count = $data->count;
		$json->total = $data->total;
		
		echo json_encode($json);
	
	}
	
	//to delete custom field files
	function delete_custom()
	{
		
		$model = $this->getModel('entry');
		
		if($model->delete_custom())	{
			$msg = JText::_('IMAGEDELETESUCCESS');
			echo '{"result":"success", "msg":"'.$msg.'"}';
		}
		else	{
			
			echo '{"result":"error", "error":"'.$model->getError().'"}';
			
		}
		
	}
	
	//to load the fields in entry form layout
	function loadfields()
	{
		
		$cats = JRequest::getVar( 'catid', array(), 'post', 'array' );
		$id = JRequest::getInt('id', 0);
		
		$html = $this->field->loadformfields($id, array('cats'=>$cats));
		
		echo $html;
		
	}
	
	//to reload the cats in menu parameters
	
	function loadcats()
	{
		
		$model = $this->getModel('entry');
		
		$cats = $model->getCats();
		$catid = JRequest::getInt('catid', 0);
		
		$list = '<option value="">'.JText::_('ALL').'</option>';
		
		for($i=0;$i<count($cats);$i++)	{
		
			$list .= '<option value="'.$cats[$i]->id.'"';
			if($catid==$cats[$i]->id)
				$list .= ' selected="selected"';
			$list .= '>'.$cats[$i]->treename.'</option>';
			
		}
		
		echo $list;
		
	}
	
}