<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );


class JoomdModelJoomd extends JModel
{
    
    var $_total = null;
	var $_pagination = null;
	
	function __construct()
	{
		parent::__construct();

	}
	
	function getIcons()
	{
		
		$items = Joomd::getPlugins('icon');
		
		$data = array();
		
		for($i=0;$i<count($items);$i++)	{
			
			if(is_file(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php'))	{
				
				require_once(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php');
				
				$class = "plg_".$items[$i]->view;
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'icon_display'))	{
						
						$items[$i]->iconhtml = $class->icon_display();
						$data[] = $items[$i];
						
					}
				
				}
				
			}
			
		}
		
		return $data;
	
	}
	
	function getPanel()
	{
		
		$items = Joomd::getPlugins('panel');
		
		$data = array();
		
		$item = new stdClass();
		
		$item->name = JText::_('WELCOMETEXT');
		$item->panelhtml = JText::_('WELCOMELONGTEXT');
		
		array_push($data, $item);
		
		$item = $this->getStates();
		
		array_push($data, $item);
		
		for($i=0;$i<count($items);$i++)	{
			
			if(is_file(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php'))	{
				
				require_once(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php');
				
				$class = "plg_".$items[$i]->view;
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'panel_display'))	{
						
						$items[$i]->panelhtml = $class->panel_display();
						$data[] = $items[$i];
	
					}
				
				}
				
			}
			
		}
		
		return $data;
		
	}
	
	function getStates()
	{
		
		$item = new stdClass();
		
		$item->name = JText::_('STATIS');
		
		$query = 'select count( * ) from #__joomd_category';
		$this->_db->setQuery( $query );
		$cats = $this->_db->loadResult();
		
		$query = 'select count( * ) from #__joomd_entry';
		$this->_db->setQuery( $query );
		$entries = $this->_db->loadResult();
		
		$query = 'select count( * ) from #__joomd_field';
		$this->_db->setQuery( $query );
		$fields = $this->_db->loadResult();
		
		$item->panelhtml = '<table class="adminlist">';
		
		$item->panelhtml .= '<tr><th>'.JText::_('ITEM').'</th><th>'.JText::_('COUNT').'</th></tr>';
		
		$item->panelhtml .= '<tr><th>'.JText::_('CAT').'</th><th>'.$cats.'</th></tr>';
		$item->panelhtml .= '<tr><th>'.JText::_('ENTRIES').'</th><th>'.$entries.'</th></tr>';
		$item->panelhtml .= '<tr><th>'.JText::_('FIELDS').'</th><th>'.$fields.'</th></tr>';
		
		$item->panelhtml .= '</table>';
				
		return $item;
		
		
	}
	
	function getEmails()
	{
		
		$query = 'select id, core from #__joomd_field where type = 8';
		$this->_db->setQuery( $query );
		$items = (array)$this->_db->loadObjectList();
		
		$emails = array();
		
		foreach($items as $item)	{
			
			$query = 'select typeid from #__joomd_tnf where fieldid = '.$item->id;
			$this->_db->setQuery( $query );
			$types = (array)$this->_db->loadResultArray();
			
			if(!count($types))
				continue;
			
			$query = 'select distinct(p.view) as plugin from #__joomd_types as t join #__joomd_plugins as p on t.plugin=p.id where t.id in ('.implode(',', $types).')';
			$this->_db->setQuery( $query );
			$plugins = (array)$this->_db->loadResultArray();
			echo $this->_db->getErrorMsg();
			foreach($plugins as $plugin)	{
			
				if($item->core)	{
					
					$field = 'field_'.$item->id;
					$table = $this->_db->getPrefix().'joomd_'.$plugin;
					
					$query = 'show tables like '.$this->_db->Quote($table);
					$this->_db->setQuery( $query );
					$exists = $this->_db->loadObject();
					
					if(!empty($exists))	{
						
						$query = 'show fields from '.$table.' LIKE '.$this->_db->Quote($field);
						$this->_db->setQuery( $query );
						$exists = $this->_db->loadObject();
						
						if(!empty($exists))	{
							
							$query = 'select '.$field.' from '.$table.' where '.$field.' <> ""';
							$this->_db->setQuery( $query );
							$e = $this->_db->loadResultArray();
							
							$emails += $e;
							
						}
						
					}
										
				}
				else	{
					
					$field = 'value';
					$table = $this->_db->getPrefix().'joomd_'.$plugin.'_fielddata';
					
					$query = 'show tables like '.$this->_db->Quote($table);
					$this->_db->setQuery( $query );
					$exists = $this->_db->loadObject();
					
					if(!empty($exists))	{
						
						$query = 'show fields from '.$table.' LIKE '.$this->_db->Quote($field);
						$this->_db->setQuery( $query );
						$exists = $this->_db->loadObject();
						
						if(!empty($exists))	{
							
							$query = 'select '.$field.' from '.$table.' where '.$field.' <> "" and fieldid = '.$item->id;
							$this->_db->setQuery( $query );
							$e = $this->_db->loadResultArray();
							echo $this->_db->getErrorMsg();
							$emails += $e;
							
						}
						
					}
					
				}
				
				
			
			}
			
		}
		
		return array_unique($emails);
		
	}

}

?>