<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/ 
 
// No direct access
defined('_JEXEC') or die('Restricted access');
 

class TableEntry extends JTable
{
    /**
     * Primary Key
     *
     * @var int
     */
    var $id = null;
 
    /**
     * @var string
     */
    
	var $alias = null;
	var $typeid = 1;
	var $featured = 0;
	var $ordering = null;
	var $published = 1;
	var $created = null;
	var $created_by = null;
	var $hits = null;
	var $access = null;
    
    function TableEntry( &$db ) {
        parent::__construct('#__joomd_entry', 'id', $db);
		
		$this->_field = new JoomdFields('entry');
		
    }
	
	function loadentry($id=null)
	{
		
		$this->load($id);
		
		if(!$this->id)	{
			
			$this->id = 0;
			$this->published = 1;
			
			$field = new JoomdFields('entry');
			
			$fields = (array)$field->getCoreFields();
			
			foreach($fields as $f)
			{
				
				$name = 'field_'.$f->id;
				
				$this->$name = null;
				
			}
			
		}
		
		return $this;
		
	}
	
	function checkentry($post)
	{
		
		$obj->result = 'error';
		$obj->file = array();
		
		settype($post['id'], 'int');
		
		if(!count($post['cats']))	{
			$obj->error = JText::_('PLSSELATLOCAT');
			return $obj;
		}
		
		$firstfield = $this->_field->get_firstfield(array('core'=>false,'type'=>1, 'cats'=>$post['cats']));
		
		if($firstfield->id)
			$this->alias = empty($this->alias)?$post['field_'.$firstfield->id]:$post['alias'];
		
		$this->alias = JFilterOutput::stringURLSafe($this->alias);
		
		$query = 'select count(*) from #__joomd_entry where alias = "'.$this->alias.'" and id <> '.$post['id'];
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if($count)	{
			$obj->error = JText::sprintf('DUPLICATEALIAS', $this->alias);
			return $obj;
		}
		
		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =  JFactory::getDate();
			if(JD_VERSION == 15)
				$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
			else
				$this->alias = $datenow->format("Y-m-d-H-i-s");
		}
		
		$fields = $this->_field->getFields(array('cats'=>$post['cats']));
		
		foreach($fields as $field)
		{
			switch($field->type)
			{
				
				case 10:
				case 11:
				case 12:
				
				if(!isset($_FILES['field_'.$field->id]) and !$field->required)
					continue;
				
				$file = $this->_field->checkField($post['id'], $field->id);
				
				foreach((array)$file as $f)	{
				
					array_push($obj->file, $f);
					
					if(isset($f->error))	{
						$obj->error = $f->error;
						return $obj;
					}
				
				}
								
				break;
				
				default:
				
				if(!isset($_POST['field_'.$field->id]) and !$field->required)
					continue;
				
				if(!$this->_field->checkField($post['id'], $field->id))	{
					$obj->error = $this->_field->getError();
					return $obj;
				}
				
				break;
				
			}
			
		}
		
		$obj->result = 'success';
		
		return $obj;
		
	}
	
	function storeentry($post)
	{
		
		if(!parent::store())	{
			$this->setError(parent::getError());
			return false;
		}
		
		$fields = $this->_field->getFields(array('cats'=>$post['cats']));
		
		if(!$this->_field->saveFields($this->id, $fields))	{
			$this->setError($this->_field->getError());
			return false;
		}
		
		return true;
		
	}
	
	function bind($from, $ignore=array())
	{
		
		if(!$from['id'])	{
			
			$from['ordering'] = 1;
			$query = 'select ordering from #__joomd_entry order by ordering desc limit 1';
			$this->_db->setQuery( $query );
			$from['ordering'] += $this->_db->loadResult();
			
			$date =  JFactory::getDate();
			$user =  JFactory::getUser();
			
			$from['created'] = $date->toMySQL();
			$from['created_by'] = $user->id;
			
		}
		
		return parent::bind($from, $ignore);
				
	}
	
	function delete($oid = null)
	{
		
		if(!parent::delete($oid))
			return false;
		else	{
			$query = 'delete c, f from #__joomd_entry_cat as c inner join #__joomd_entry_fielddata as f using(itemid) where c.itemid='.(int)$oid;
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}			
		}
		
		return true;
		
	}
	
}
