<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/ 
 
// No direct access
defined('_JEXEC') or die('Restricted access');
 

class TableType extends JTable
{
    /**
     * Primary Key
     *
     * @var int
     */
    var $id = null;
 
    /**
     * @var string
     */
    
    var $name = null;
	var $alias = null;
	var $descr = null;
	var $plugin = null;
	var $ordering = null;
	var $published = 1;
	var $access = null;
    
    function TableType( &$db ) {
        parent::__construct('#__joomd_types', 'id', $db);
    }
	
	function bind($array, $ignore = '')
	{
		
		if(!$array['id'])	{
			
			$array['ordering'] = 1;
			$query = 'select ordering from #__joomd_types order by ordering desc limit 1';
			$this->_db->setQuery( $query );
			$array['ordering'] += $this->_db->loadResult();
			
		}
		
		return parent::bind($array, $ignore);
		
	}
	
	function check()
	{
		
		$this->id = intval($this->id);
		$this->plugin = intval($this->plugin);
		
		if($this->name == "")	{
			$this->setError( JText::_('PLSENTTYPTIT') );
			return false;
		}
		
		$query = 'select count(*) from #__joomd_types where id <> '.$this->id.' and lower(name) = '.$this->_db->Quote(strtolower($this->name));
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if($count)	{
			$this->setError( JText::sprintf('TITLEALREADYEXISTS', JText::_('TITLE')));
			return false;
		}
		
		if(!$this->plugin)	{
			$this->setError( JText::_('PLSSELPLG'));
			return false;
		}
		
		$this->alias = empty($this->alias)?$this->name:$this->alias;
		
		$this->alias = JFilterOutput::stringURLSafe($this->alias);
		
		$query = 'select count(*) from #__joomd_types where alias = "'.$this->alias.'" and id <> '.$this->id;
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if($count)	{
			$this->setError(JText::sprintf('DUPLICATEALIAS', $this->alias));
			return false;
		}

		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =  JFactory::getDate();
			if(JD_VERSION == 15)
				$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
			else
				$this->alias = $datenow->format("Y-m-d-H-i-s");
		}
		
		return parent::check();
		
	}
	
	function delete($oid=null)
	{
		
		if($oid == 1)	{
			$this->setError(JText::_('AUTHERRORCANTDELETE'));
			return false;
		}
		
		return parent::delete($oid);
		
	}
	
}
