<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class JoomdControllerSearch extends JoomdController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
						
		$this->config =  Joomd::getConfig('entry');
		$this->_user =  Joomd::getUser('entry');
		$this->type = Joomd::getType();		
		
		$this->checkAccess();
		
		require_once(JPATH_COMPONENT.'/libraries/classes/fields.php');
		
		$this->field = new JoomdFields($this->type->plugin);
		
	}
	
	function checkAccess()
	{
		
		if($this->config->list == 1 and $this->_user->get('guest'))
			Joomd::redirect(JRoute::_('index.php?option='.COM_USER.'&view=login&return='.base64_encode(JRoute::_('index.php?option=com_joomd&view=search'))), JText::_('PLSLOHTOACC'));
		
	}
	
	function search()
	{
	
		// Check for request forgeries (removed in JoomD v2.1)
		//JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$post = JRequest::get('post');
		
		$arr = array();
		
		//remove unnecessary variables
		unset($post['task']);
		unset($post['submit']);
		
		foreach($post as $k=>$v)
		{
			
			if(!empty($v) and !strstr($k, 'multiselect'))
				$arr[$k] = $v;
			
		}
	
		$uri = JURI::getInstance();
		$uri->setQuery($arr);
		$uri->setVar('option', 'com_joomd');
		$uri->setVar('view', 'search');
		$uri->setVar('layout', 'search');
		
		$this->setRedirect(JRoute::_('index.php'.$uri->toString(array('query', 'fragment')), false));
	
	}
	
	function getItems()
	{
		
		$model = $this->getModel('search');
		$layout = JRequest::getCmd('layout', 'default');
		
		$params = $model->getParams();
		
		$this->items = $model->getItems();
		$this->fields =  $this->field->getFields(array('cats'=>$params->cats, 'published'=>1, 'list'=>true));
		
		ob_start();
		$n = $params->limitstart;
		for($i=0;$i<count($this->items);$i++)	{
		
			$item =  $this->items[$i];
			
			$class = $n%2?'entry_row':'entry_row_bg';
			
			echo '<div class="'.$class.'">';
			
			$path = Joomd::getTemplatePath('search', $layout.'_item.php');
			
			require($path);
			
			echo '<div class="clr"></div></div>';
			$n++;
		}
		
		$html = ob_get_contents();
		
		ob_end_clean();
		
		$data = new stdClass();
		
		$data->html = $html;
		$data->count = count($this->items);
		$data->total = $params->total;
		
		return $data;
		
	}
	
	function loaditems()
	{
		
		$data = $this->getItems();
		
		$json = new stdClass();
		
		$json->result = "success";
		$json->html = $data->html;
		$json->count = $data->count;
		$json->total = $data->total;
		
		jexit(json_encode($json));
	
	}

}