<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

//Contains the function to initialize all the classes

class Joomd	{
	
	var $_doc = null;
	var $_app = null;
	var $_db = null;
	var $_abase = null;
	
	function __construct()
	{
		
		$this->_doc = JFactory::getDocument();
		
	}
	
	//initializes all the settings to work with the joomd framework
	function initialize()
	{
		
		$this->_abase = JRequest::getInt('abase', 0);
		
		JHTML::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_joomd'.DS.'libraries'.DS.'html'.DS.'html');
		
		jimport( 'joomla.html.parameter' );
		
		$v = explode('.', JVERSION);
		
		if(version_compare(JVERSION, '1.6.0', 'lt'))	{
			define('JD_VERSION', 15);
			define('COM_USER', 'com_user');
		}
		else	{
			define('JD_VERSION', JVERSION);
			define('COM_USER', 'com_users');
		}
		
	}
	
	//returns plugin array of objects
	public static function getPlugins($order = 'ordering')
	{
	
		$db =  JFactory::getDBO();
	
		$query = 'select * from #__joomd_plugins where published = 1 order by '.$order.' asc';
		$db->setQuery( $query );
		$items = $db->loadObjectList();
	
		return $items;
	
	}
	
	//returns toolbar object
	public static function getToolbar()
	{
	
		// check whether it is already loaded
		static $loader;
		
		if($loader)
			return;
			
		$loader = true;
		
		require_once(JPATH_ROOT.DS.'components/com_joomd/libraries/html/toolbar.php');
		
		$toolbar = new JoomdToolbar();
		
		return $toolbar;
	
	}
	
	//return config object based on all the plugins
	public static function getConfig($plugins = null)
	{
		
		$db =  JFactory::getDBO();
		
		$query = 'select i.*, t.name as theme from #__joomd_config as i left join #__joomd_templates as t on i.template=t.id';
		$db->setQuery( $query );
		$config = $db->loadAssoc();
		
		$params = json_decode($config['social']);
		
		$config['social'] = new stdClass();
		
		$config['social']->share = isset($params->share)?$params->share:0;
		$config['social']->fblike = isset($params->fblike)?$params->fblike:0;
		$config['social']->tweet = isset($params->tweet)?$params->tweet:0;
		$config['social']->gplus = isset($params->gplus)?$params->gplus:0;
		
		foreach((array)$plugins as $plugin)	{
		
			if(!empty($plugin) and is_file(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php'))	{
				
				require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php');
					
				$class = "plg_".$plugin;
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'getConfig'))	{
						
						$cconfig = $class->getConfig();
						$config = array_merge($cconfig, $config);
						
					}
				
				}
				
			}
		
		}
		
		$config = (object)$config;
		
		return $config;
	
	}
	
	//returns user object with all the available elements in all the plugins if exists some
	public static function getUser($plugins = null)
	{
		
		$user =  JFactory::getUser();
		
		$db =  JFactory::getDBO();
		
		foreach((array)$plugins as $plugin)	{
		
			if(!empty($plugin) and is_file(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php'))	{
				
				require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php');
					
				$class = "plg_".$plugin;
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'getUser'))	{
						
						$puser = $class->getUser();
						
						unset($puser['id']);
						unset($puser['username']);
						unset($puser['email']);
						unset($puser['password']);
						unset($puser['gid']);
						unset($puser['usertype']);
						
						foreach((array)$puser as $k=>$v)
							$user->$k = $v;
						
					}
				
				}
				
			}
		
		}
		
		return $user;
		
	}
	
	public static function CanAccessItem($item)
	{
		
		$user =  JFactory::getUser();
		
		if(version_compare(JVERSION, '1.6.0', 'lt'))	{
			if($item->access > (int)$user->aid)
				return false;
		}
		else	{
			
			if(!in_array($item->access, $user->getAuthorisedViewLevels()))
				return false;
			
		}
		
		return true;
		
	}
	
	//checks the type access and return the type object
	public static function getType($typeid = null)
	{
		
		$user =  JFactory::getUser();
		
		$typeid = empty($typeid)?JRequest::getInt('typeid', 1):(int)$typeid;
		
		if(!$typeid)
			Joomd::redirect('index.php', JText::_('TYPENOTFOUND'));
			
		$db =  JFactory::getDBO();
		
		$query = 'select i.*, p.view as plugin from #__joomd_types as i join #__joomd_plugins as p on (i.plugin=p.id and p.published=1) where i.published = 1 and i.id = '.$typeid;
		$db->setQuery( $query );
		$type = $db->loadObject();
		
		if(empty($type))
			Joomd::redirect('index.php', JText::_('TYPENOTFOUND'));
		
		if(!Joomd::CanAccessItem($type))	{
			if($user->get('guest'))	{
				Joomd::redirect(JRoute::_('index.php?option='.COM_USER.'&view=login'), JText::_('PLSLOGTOACC'));
				return;
			}
			else	{
				Joomd::redirect('index.php', JText::_('AUTH_NOACCESS'));
				return;
			}
			
		}
		
		JRequest::setVar('typeid', $type->id);
		
		return $type;
		
	}
	
	//returns the template path from all the available path
	public static function getTemplatePath($view, $file)
	{
		
		$mainframe =  JFactory::getApplication();
		
		$config = Joomd::getConfig();
		
		$template = $mainframe->getTemplate();
		
		$paths = array();
		
		$paths[] = JPATH_COMPONENT.DS.'templates'.DS.$config->theme.DS.$view;
		$paths[] = JPATH_THEMES.DS.$template.DS.'html'.DS.'com_joomd'.DS.$view;
		$paths[] = JPATH_COMPONENT.DS.'views'.DS.$view.DS.'tmpl';
		
		jimport('joomla.filesystem.path');
		
		$template = JPath::find($paths, $file);
		
		return $template;
		
	}
	
	//redirects/display the message based on request ( json type )
	public static function redirect($url, $msg, $json=true)
	{
		
		$mainframe =  JFactory::getApplication();
		
		$abase = JRequest::getInt('abase', 0);
		
		if($abase)	{
			
			if($json)
				jexit('{"result":"error", "error":"'.$msg.'"}');
			else
				jexit($msg);
		}
		else
			$mainframe->redirect($url, $msg);
		
	}
	
	//system notifications sent from all joomd
	public static function notify($subject, $body, $params=array())	{
		
		$mainframe = JFactory::getApplication();
		$db		=  JFactory::getDBO();
		
		$params['mode'] = isset($params['mode'])?$params['mode']:true;
		$params['from'] = isset($params['from'])?$params['from']:null;
		$params['to'] = isset($params['to'])?$params['to']:null;
		
		
		//assign sender based on the parameters
		if(empty($params['from']))	{
			
			$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
			$fromname 	= $mainframe->getCfg( 'fromname' );
		
		}
		else	{
			
			if(is_array($params['from']))	{
				$mailfrom 	= $params['from'][0];
				$fromname 	= $params['from'][1];
			}
			else	{
				$mailfrom 	= $params['from'][0];
				$fromname 	= JText::_('ANONYMOUS');
			}
			
		}
				
		//get all super users with system email enabled
		$query = 'SELECT name, email' .
				' FROM #__users' .
				' WHERE block = 0 and sendEmail = 1';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// assign the same sender if not exists
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
		
		if(empty($params['to']))	{
			$config = Joomd::getConfig();
		
			$recipient = empty($recipient)?array():explode(',', $config->email);
		}
		else	{
			$recipient = (array)$params['to'];
		}
		
		if(count($recipient))	{
			
			foreach ( $recipient as $email )	{
				ob_start();
				$result = JUtility::sendMail($mailfrom, $fromname, $email, $subject, $body, $params['mode'], null, null, null, $mailfrom);
				ob_clean();
				if(is_object($result))
					return $result;
				
			}
			
		}
		
		else	{
		
			// get superadministrators id
			foreach ( $rows as $row )
			{
				ob_start();
				$result = JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $body, $params['mode']);
				ob_clean();
				if(is_object($result))
					return $result;
				
			}
		
		}
		
		return true;
		
	}
	
	//to create the thumbnail in the thumbs directory
	public static function create_scaled_image($file_path, $options) {
		
        $new_file_path = dirname($file_path).'/thumbs/'.basename($file_path);
		
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		
		JFolder::create(dirname($new_file_path));
			
        list($img_width, $img_height) = @getimagesize($file_path);
        if (!$img_width || !$img_height) {
            return false;
        }
       
	   $wr = $options['max_width'] / $img_width;
		$hr = $options['max_height'] / $img_height;
		
		if($wr and $hr)	{
			$scale = min(
				$wr,
				$hr
			);
		}
		else	{
			$scale = max(
				$wr,
				$hr
			);
		}
	   
        if ($scale > 1) {
            $scale = 1;
        }
        $new_width = $img_width * $scale;
        $new_height = $img_height * $scale;
        $new_img = @imagecreatetruecolor($new_width, $new_height);
        switch (strtolower(substr(strrchr(basename($file_path), '.'), 1))) {
            case 'jpg':
            case 'jpeg':
                $src_img = @imagecreatefromjpeg($file_path);
                $write_image = 'imagejpeg';
                break;
            case 'gif':
                @imagecolortransparent($new_img, @imagecolorallocate($new_img, 0, 0, 0));
                $src_img = @imagecreatefromgif($file_path);
                $write_image = 'imagegif';
                break;
            case 'png':
                @imagecolortransparent($new_img, @imagecolorallocate($new_img, 0, 0, 0));
                @imagealphablending($new_img, false);
                @imagesavealpha($new_img, true);
                $src_img = @imagecreatefrompng($file_path);
                $write_image = 'imagepng';
                break;
            default:
                $src_img = $image_method = null;
        }
        $success = $src_img && @imagecopyresampled(
            $new_img,
            $src_img,
            0, 0, 0, 0,
            $new_width,
            $new_height,
            $img_width,
            $img_height
        ) && $write_image($new_img, $new_file_path);
        // Free up memory (imagedestroy does not delete files):
        @imagedestroy($src_img);
        @imagedestroy($new_img);
        return $success;
    }
	
	//display footer e.g. version info
	public static function displayfooter()
	{
		
		echo '<div class="comfooter">'.JText::_('VERSIONINFO').'</div>';
		
	}
	
	//finalize the rendring
	function finalize()
	{
				
		//if it's ajax based call the exit the execution
		if($this->_abase)
			jexit();
		
	}
	
	public static function onAfterDisplay()
	{
		
		$db =  JFactory::getDBO();
	
		$query = 'select view from #__joomd_plugins where published = 1 and entry = 2 order by ordering asc';
		$db->setQuery( $query );
		$plugins = $db->loadResultArray();
		
		ob_start();
		
		foreach((array)$plugins as $plugin)	{
		
			if(!empty($plugin) and is_file(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php'))	{
				
				require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomd'.DS.'classes'.DS.'plg_'.$plugin.'.php');
					
				$class = "plg_".$plugin;
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'onAfterDisplay'))	{
						
						$class->onAfterDisplay();
						
					}
				
				}
				
			}
		
		}
		
		$html = ob_get_contents();
		ob_clean();
		
		return $html;
		
	}
	
	
}