<?php
 
/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/
 
// No direct access
 
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport( 'joomla.application.component.model' );
 
class JoomdModelEntry extends JModel
{
	
	function __construct()
	{
		parent::__construct();
 
        $mainframe =  JFactory::getApplication();
		
		$context			= 'com_joomd.entry.list.'; 
        // Get pagination request variables
        $this->_limit = JRequest::getInt('limit', $mainframe->getCfg('list_limit'));
		$this->_limitstart = JRequest::getInt('limitstart', 0 );
 
        // In case limit has been changed, adjust it
        $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
		
		$menus		=  $mainframe->getMenu();
		$menu    	= $menus->getActive();
		
		//get the order by from the menu parameters
		$params = $mainframe->getParams();
		
		if(is_object($menu))	{
		if(!strstr($menu->link, 'view=entry'))
			$params->set('orderby', 'ordering asc');
		}
		
		$orderby = explode(' ', $params->def('orderby', 'ordering asc'));

		
		$orderby[1] = isset($orderby[1])?$orderby[1]:'';
		
		$this->_filter_order	= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', $orderby[0], 'cmd' );
        $this->_filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', $orderby[1], 'word' );
		$this->_filter_search = $mainframe->getUserStateFromRequest( $context.'filter_search', 'filter_search', '',	'string' );
		$this->_filter_search = JString::strtolower( $this->_filter_search );
		
		$this->_key			= $mainframe->getUserStateFromRequest( $context.'key', 'key', '',	'string' );
		$this->_key			= JString::strtolower( $this->_key );
		
		$this->typeid = $mainframe->getUserStateFromRequest( $context.'typeid', 'typeid', 1,	'int' );
				
		$this->userid = JRequest::getInt('userid', 0);
		$this->catid = JRequest::getInt('catid', 0);
		$this->featured = JRequest::getInt('featured', 0);
		$this->Itemid = JRequest::getVar('Itemid', '');
		
		$this->_user = Joomd::getUser();
		
		$this->config =  Joomd::getConfig('entry');
				
		$this->_field = new JoomdFields('entry');
		
		$this->setId();

	}
	
	function setId()
	{
				 
		$id = JRequest::getInt('id', 0);
		
		$layout = JRequest::getCmd('layout', '');
		
		if($layout == "detail")	{
			
			if(!$id)
				Joomd::redirect('index.php?option=com_joomd&view=entry', JText::_('NOEF'));
				
			$query = 'update #__joomd_entry set hits = hits + 1 where id = ' . $id;
			$this->_db->setQuery( $query );
			$this->_db->query();	
		
		}
		
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function getUser()
	{
		
		return Joomd::getUser();
		
	}
	
	function _buildQuery()
	{
		
		$query = 'select i.*, nullif(u.id,null) as created_by, if(u.id, u.name, "'.JText::_('ANONYMOUS').'") as creator from #__joomd_entry as i left join #__users as u on i.created_by=u.id';

		return $query;
		
	}
	
	function getItem()
	{
		
		$query = $this->_buildQuery();
		
		$where = array();
		
		$where[] = 'i.published = 1';
		$where[] = 'i.id = '.$this->_id;
		
		if(JD_VERSION == 15)
			$where[] = 'i.access <= '.(int)$this->_user->aid;
		else
			$where[] = 'i.access in ('.implode(',', $this->_user->getAuthorisedViewLevels()).')';
		
		$query .= ' where ' . implode(' and ', $where);
		
		$this->_db->setQuery( $query );
		$item = $this->_db->loadObject();
		
		$item->save = $this->getSaved($item->id);
		
		$this->typeid = $item->typeid;
		
		return $item;
	
	}
	
	function getSaved($id)
	{
		
		if($this->_user->get('guest'))	{
			$ip = $_SERVER['REMOTE_ADDR'];
			$query = 'select save from #__joomd_user_entry where itemid = '.(int)$id.' and ip = '.$this->_db->Quote($ip);
		}
		else	{
			$query = 'select save from #__joomd_user_entry where itemid = '.(int)$id.' and userid = '.$this->_user->id;
		}
		
		$this->_db->setQuery( $query );
		$save = $this->_db->loadResult();
		
		return intval($save);
		
	}
	
	function &getItems()
    {
        if(empty($this->_data))	{
		
			$query = $this->_buildQuery();
			
			$filter = $this->_buildItemFilter();
			$query .= $filter;
			$orderby = $this->_buildItemOrderBy();
			$query .= $orderby;
			
			$this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
			
		}

        return $this->_data;
    
	}
	
	function _buildItemFilter()
	{
 
        $where = array();
		
		$where[] = 'i.published = 1';
		
		if(JD_VERSION == 15)
			$where[] = 'i.access <= '.(int)$this->_user->aid;
		else
			$where[] = 'i.access in ('.implode(',', $this->_user->getAuthorisedViewLevels()).')';
		
		$where[] = 'i.typeid = '.$this->typeid;
		
		if($this->catid)	{
			
			$query = 'select itemid from #__joomd_entry_cat where catid = '.$this->catid;
			$this->_db->setQuery( $query );
			$entries = $this->_db->loadResultArray();
			
			$where[] = count($entries)?'i.id in ('.implode(', ', $entries).')':'i.id=0';
			
		}
		
		if($this->featured)	{
			$where[] = 'i.featured = 1';
		}
		
		if($this->userid)	{
			$where[] = 'i.created_by = '.$this->userid;
		}
		
		$firstfield =  $this->_field->get_firstfield();
		
		if($this->config->asearch and !empty($this->_key) and $this->_key <> "all")	{
			
			$key = substr($this->_key, 0, 1);
			
			if($key == '#')	{
				$where[] = 'lower(i.field_'.$firstfield->id.') regexp '.$this->_db->Quote( '^[0-9]+', false );
			}
			else
				$where[] = 'lower(i.field_'.$firstfield->id.') like '.$this->_db->Quote( $key.'%', false );
			
		}
					
		$filter = ' where ' . implode(' and ', $where);
 
        return $filter;
	}
	
	function _buildItemOrderBy()
	{
 
        $orderby = ' group by i.id order by '.$this->_filter_order.' '.$this->_filter_order_Dir;
 
        return $orderby;
	}
	
	function getParams()
  	{	
		
		$layout = JRequest::getCmd('layout', 'default');
		
		$this->item = new stdClass();
		
		$this->item->option = 'com_joomd';
		$this->item->view = 'entry';
		$this->item->abase = 1;
		$this->item->task = '';
		$this->item->typeid = $this->typeid;
		$this->item->catid = $this->catid;
		$this->item->userid = $this->userid;
		$this->item->featured = $this->featured;
		$this->item->Itemid = $this->Itemid;
		
		if($layout <> "detail")	{
			
			$this->item->limit = $this->_limit;
			$this->item->limitstart = $this->_limitstart;
			$this->item->key = $this->_key;
			$this->item->filter_search = $this->_filter_search;
			$this->item->filter_order = $this->_filter_order;
			$this->item->filter_order_Dir = $this->_filter_order_Dir;
			
			// Load the plugin if it doesn't already exist
			if (empty($this->_total)) {
				$query = $this->_buildQuery();
				$filter = $this->_buildItemFilter();
				$query .= $filter;
				$orderby = $this->_buildItemOrderBy();
				$query .= $orderby;
				$this->item->total = (int) $this->_getListCount($query);    
			}
		
		}
		
        return $this->item;
  	}
	
	function getCategory()
	{
		
		if($this->catid)	{
			
			$query = 'select * from #__joomd_category where published = 1 and id = '.$this->catid;
			$this->_db->setQuery( $query );
			$item = $this->_db->loadObject();
			
			return $item;
			
		}
		
	}
	
	function checkCategoryAccess($id=null)
	{
		
		$id = empty($id)?$this->_id:(int)$id;
		
		$query = 'select * from #__joomd_category where id in ( select catid from #__joomd_entry_cat where itemid = '.$id.' )';
		$this->_db->setQuery( $query );
		$items = (array)$this->_db->loadObjectList();
		
		if(count($items) == 1)	{
			return Joomd::CanAccessItem($items[0]);
		}
		
		foreach($items as $item)	{
			
			if(Joomd::CanAccessItem($item))
				return true;
			
		}
		
		return false;
		
	}
	
	function report_item()
	{
				
		$app = JFactory::getApplication();
		$sitename = $app->getCfg('sitename');
		
		$obj = new stdClass();
		
		$obj->result = "error";
		
		$id = JRequest::getInt('id', 0);
		$email = JRequest::getVar('email', '');
		$comment = JRequest::getVar('comment', '');
		
		$date =  JFactory::getDate();
		$now = $date->toMySQL();
		
		$ip = $_SERVER['REMOTE_ADDR'];
		
		if(!$id)	{
			$obj->error = JText::_('ITEMNOTFOUND');
			return $obj;
		}
		
		if(empty($email))	{
			$obj->error = JText::_('ENTEREMAIL');
			return $obj;
		}
		if(empty($comment))	{
			$obj->error = JText::_('ENTERCOMMENT');
			return $obj;
		}
		
		if($this->_user->get('guest'))	{
			$query = 'select count(*) from #__joomd_user_entry where ip = "'.$ip.'" and itemid = '.$id.' and datediff("'.$now.'", report) < 1';
		}
		else	{
			$query = 'select count(*) from #__joomd_user_entry where userid = '.$this->_user->id.' and itemid = '.$id.' and datediff("'.$now.'", report) < 1';
		}
		
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if($count)	{
			$obj->error = JText::_('ALREADYREPORTED');
			return $obj;
		}
		
		$subject = JText::sprintf('REPORT_SUBJECT', $sitename);
		
		$body = JText::sprintf('REPORT_MAIL_BODY', $email, $comment);
		
		$sent = Joomd::notify($subject, $body);
		
		if(is_object($sent))	{
			$obj->error = JText::_('SORRYNOTREPORTED');
			return $obj;
		}
		
		$obj->result = 'success';
		$obj->msg = JText::_('SUCCESSFUL_REPORT');
		
		if($this->_user->get('guest'))	{
			
			$query = 'select count( * ) from #__joomd_user_entry where itemid = '.$id.' and ip = '.$this->_db->Quote($ip);
			$this->_db->setQuery( $query );
			$count = $this->_db->loadResult();
			
			if($count)	{
				$query = 'update #__joomd_user_entry set report = '.$this->_db->Quote($now).' where itemid = '.$id.' and ip = '.$this->_db->Quote($ip);
			}
			else	{
				$query = 'insert into #__joomd_user_entry (itemid, report, ip) values ('.$id.', '.$this->_db->Quote($now).', '.$this->_db->Quote($ip).')';
			}
			
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$obj->error = $this->_db->getErrorMsg();
				return $obj;
			}
			
		}
		
		else	{
			
			$query = 'select count( * ) from #__joomd_user_entry where itemid = '.$id.' and userid = '.$this->_user->id;
			$this->_db->setQuery( $query );
			$count = $this->_db->loadResult();
			
			if($count)	{
				$query = 'update #__joomd_user_entry set report = '.$this->_db->Quote($now).' where itemid = '.$id.' and userid = '.$this->_user->id;
			}
			else	{
				$query = 'insert into #__joomd_user_entry (itemid, report, userid) values ('.$id.', '.$this->_db->Quote($now).', '.$this->_user->id.')';
			}
			
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$obj->error = $this->_db->getErrorMsg();
				return $obj;
			}
			
		}

		return $obj;
				
	}
	
	function save_item()
	{
		
		JRequest::checkToken() or jexit( '{"result":"error", "error":"'.JText::_('INVALIDTOKEN').'"}' );
		
		$obj = new stdClass();
		
		$obj->result = "error";
		
		$id = JRequest::getInt('id', 0);
		
		if(!$id)	{
			$obj->error = JText::_('ITEMNOTFOUND');
			return $obj;
		}
		
		if($this->_user->get('guest'))	{
			$obj->error = JText::_('LOGINFIRST');
			return $obj;
		}
			
		$query = 'select * from #__joomd_user_entry where userid = '.$this->_user->id.' and itemid = '.$id;
		$this->_db->setQuery( $query );
		$item = $this->_db->loadObject();
		
		$save = empty($item)?0:$item->save;
		
		if($save)	{
			$obj->error = JText::_('ITEMALREADYSAVED');
			return $obj;
		}
		
		if(empty($item))
			$query = 'insert into #__joomd_user_entry (userid, itemid, save) values ('.$this->_user->id.', '.$id.', 1)';
		else
			$query = 'update #__joomd_user_entry set save = 1 where userid = '.$this->_user->id.' and itemid = '.$id;
			
		$this->_db->setQuery( $query );
		
		if(!$this->_db->query())	{
			$obj->error = $this->_db->getErrorMsg();
			return $obj;
		}
		
		$obj->result = 'success';
		$obj->msg = JText::_('SAVEDSUCCESSFULLY');
		
		return $obj;
				
	}
	
	function contact_item()
	{
		
		$obj = new stdClass();
		$obj->result = "error";
		
		$id = JRequest::getInt('id', 0);
		$name = JRequest::getVar('name', '');
		$email = JRequest::getVar('email', '');
		$phone = JRequest::getVar('phone', '');
		$enquiry = JRequest::getVar('enquiry', '');
		
		$date =  JFactory::getDate();
		$now = $date->toMySQL();
		
		$ip = $_SERVER['REMOTE_ADDR'];
		
		if(!$id)	{
			$obj->error = JText::_('ITEMNOTFOUND');
			return $obj;
		}
		if(empty($name))	{
			$obj->error = JText::_('ENTERNAME');
			return $obj;
		}
		if(empty($email))	{
			$obj->error = JText::_('ENTEREMAIL');
			return $obj;
		}
		if(empty($enquiry))	{
			$obj->error = JText::_('ENTERENQUIRY');
			return $obj;
		}
		
		if($this->_user->get('guest'))	{
			$query = 'select count(*) from #__joomd_user_entry where ip = "'.$ip.'" and itemid = '.$id.' and datediff("'.$now.'", contact) < 1';
		}
		else	{
			$query = 'select count(*) from #__joomd_user_entry where userid = '.$this->_user->id.' and itemid = '.$id.' and datediff("'.$now.'", contact) < 1';
		}
		
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if($count)	{
			$obj->error = JText::_('ALREADYCONTACTED');
			return $obj;
		}
		
		$app = JFactory::getApplication();
		$sitename = $app->getCfg('sitename');
		
		$subject = JText::sprintf('CONTACT_SUBJECT', $sitename);
		
		$body = JText::sprintf('CONTACT_MAIL_BODY', $name, $email, $phone, $enquiry);
			
		$config = Joomd::getConfig('entry');
		
		$params['to'] = empty($recipient)?array():explode(',', $config->email);
		
		if($config->notify)	{
			
			$item = $this->getItem();
			
			if($item->created_by)	{
				$o = JFactory::getUser($item->created_by);
				if(!empty($o->email))
					array_push($params['to'], $o->email);
			}
		}
		
		$sent = Joomd::notify($subject, $body, $params);
		
		if(is_object($sent))	{
			$obj->error = JText::_('SORRYENQUIRYNOTSENT');
			return $obj;
		}
		
		
		$obj->result = 'success';
		$obj->msg = JText::_('SUCCESSFUL_ENQUIRY');
		
		if($this->_user->get('guest'))	{
			
			$query = 'select count( * ) from #__joomd_user_entry where itemid = '.$id.' and ip = '.$this->_db->Quote($ip);
			$this->_db->setQuery( $query );
			$count = $this->_db->loadResult();
			
			if($count)	{
				$query = 'update #__joomd_user_entry set contact = '.$this->_db->Quote($now).' where itemid = '.$id.' and ip = '.$this->_db->Quote($ip);
			}
			else	{
				$query = 'insert into #__joomd_user_entry (itemid, contact, ip) values ('.$id.', '.$this->_db->Quote($now).', '.$this->_db->Quote($ip).')';
			}
			
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$obj->error = $this->_db->getErrorMsg();
				return $obj;
			}
			
		}
		
		else	{
			
			$query = 'select count( * ) from #__joomd_user_entry where itemid = '.$id.' and userid = '.$this->_user->id;
			$this->_db->setQuery( $query );
			$count = $this->_db->loadResult();
			
			if($count)	{
				$query = 'update #__joomd_user_entry set contact = '.$this->_db->Quote($now).' where itemid = '.$id.' and userid = '.$this->_user->id;
			}
			else	{
				$query = 'insert into #__joomd_user_entry (itemid, contact, userid) values ('.$id.', '.$this->_db->Quote($now).', '.$this->_user->id.')';
			}
			
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$obj->error = $this->_db->getErrorMsg();
				return $obj;
			}
			
		}
			
		return $obj;
				
	}
	
}
